/* keylib.ch  for use with xHarbour and FWH for SoftwareKey's "Plus" */

/*pp_compno32drivers flags*/
#define CHECK_DRIVER_STATUS		 0
#define INSTALL_DRIVER			 1
#define UNINSTALL_DRIVER		 2

/*pp_compno32drivers driver*/
#define COMPNO32_BIOS			 0x0001
#define COMPNO64_BIOS			 0x0002

/* computer number defines */
#define COMPNO_BIOS              0x0001
#define COMPNO_HDSERIAL          0x0002
#define COMPNO_HDLOCK            0x0004
#define COMPNO_HDTYPE            0x0008
#define COMPNO_NETNAME           0x0010
#define COMPNO_MACADDR           0x0020
#define COMPNO_FILESTART         0x0040
#define COMPNO_WINPRODID         0x0080
#define COMPNO_IPADDR            0x0100
#define COMPNO_MACADDR_WIN98	 0x0200
#define COMPNO_BIOS16			 0x0400
#define COMPNO_BIOS32			 0x0800
#define COMPNO_MACADDR_WINNB     0x1000
#define COMPNO_BIOS64			 0x2000	
#define COMPNO_MACADDR_4200      0x4000
/* to suppress the MessageBoxes relating to Machnm1.exe */
#define SUPPRESS_ERRORS			 0x8000 
#define COMPNO_ENHANCED			 0x10000	//use new compid algs
#define COMPNO_SERVER_MACADDR    0x20000



/* pp_copycheck() action codes */
#define ACTION_MANUAL            0x0000
#define ACTION_AUTOADD           0x0001
#define COPYCHK_STRICT           0x0002
#define COPYCHK_ENHANCED		 0x0004


/* pp_copyadd() flags */
#define COPYADD_ADDDUPE          0x0001
#define COPYADD_ERASEALL         0x0002
#define COPYADD_ENHANCED		 0x0004

/* pp_copydelete() flags */
#define COPYDEL_ALL				-1
#define COPYDEL_ENHANCED		-2

//pp_copyget flags (slot)
#define COPYGET_ENHANCED		-1

/* license file type defines */
#define LF_FILE                  1
#define LF_REGISTRY              2
#define LF_CRYPTO_BOX_VERSA      3
#define LF_CRYPTO_BOX_560        4
#define LF_INTERNET              5


/* pp_lfopen() flag defines */
#define LF_CREATE_NORMAL         0x0000
#define LF_CREATE_RDONLY         0x0001
#define LF_CREATE_HIDDEN         0x0002
#define LF_CREATE_SYSTEM         0x0004
#define LF_CREATE_MISSING        0x0008
#define LFOPEN_NOLOOP            0x0010
#define LFOPEN_NOCACHE	         0x0020
#define LFOPEN_OPENALWAYS   	 0x0040  /* used in pp_semopen to create file if not there */

/* pp_exportfile and import file flag define */
#define PPP_NOURLENCODE			0x0001

#define PPP_EZTRIGPROCESS		0x0001

							   
/* pp_lfcreate() flags */
#define LFCREATE_OVERWRITE       0x0001


/* pp_semopen() flags */
#define SEM_FILE                    0
#define SEM_TCPIP                   1


/* pp_upddate() flags */
#define UPDDATE_FORCE               1
#define UPDDATE_NOTIME              2


/* pp_lfalias() flags */
#define LFALIAS_VERIFY_CHECKSUM     1
#define LFALIAS_FIND_RECENT         2
#define LFALIAS_OVERWRITE_OLDER     4
#define LFALIAS_CREATE_MISSING      8
#define LFALIAS_SCATTER				16
#define LFALIAS_SCATTER_BACK      0x80000000	//high bit
//placeholder for LFOPEN_NOCACHE flag
#define LFALIAS_NOCACHE				32   

/* pp_eztrig1dlg() flags */
#define EZTRIG1DLG_PROCESS          1
#define EZTRIG1DLG_DELAYED          2


/* return codes for pp_eztrial1() */
#define EZTRIAL1_ERROR              0
#define EZTRIAL1_RETAIL             1
#define EZTRIAL1_DEMO               2
#define EZTRIAL1_BINDING_FAILED     3
#define EZTRIAL1_EXPIRED            4
#define EZTRIAL1_CLOCKTURNEDBACK    5
#define EZTRIAL1_PERIODIC           6
#define EZTRIAL1_EXCEEDED_USERS     7

/* flags for pp_eztrial1ex() */
#define EZTRIAL1EX_NO_NET			0x0001


/* flags for pp_gotourl() */
#define GOTOURL_BUYNOW				1

/* flags for pp_importactfile */
#define PP_EZTRIGPROCESS 1

/* flags for PP_NETOPEN*/
#define NET_SINGLE		     0x0000
#define NET_DO_NOT_UPDATE	 0x0001
#define NET_ALWAYS_CONNECTED 0x0002

/* flags for PP_SYSINFO*/
#define PP_TERMSERV		0x000001
#define PP_VMWARE		0x000002
#define PP_VIRTUALPC	0x000004
#define PP_64BIT		0x000008

//flags for pp_transfer()
#define PP_TRANSFER_ENHANCED	-1

/* miscellaneous defines */
#define TCODE_MAX                   50
#define PP_MAX_UDEF_STRINGS         10
#define PP_MAX_UDEF_NUMBERS         5
#define PP_MAX_UDEF_DATES           5




/* result codes */
#define PP_FAILURE                              0
#define PP_FALSE                                0
#define PP_SUCCESS                              1
#define PP_TRUE                                 1

#define ERR_INVALID_ATTRIBUTES                  2
#define ERR_CANNOT_CHANGE_ATTRIBS               3
#define ERR_HFILE_ERROR                         4
#define ERR_CANNOT_WRITE_FILE                   5
#define ERR_CANNOT_CLOSE_FILE                   6
#define ERR_CANNOT_OPEN_FILE                    7
#define ERR_CANNOT_READ_FILE                    8
#define ERR_CANNOT_CREATE_FILE                  9
#define ERR_CANNOT_DELETE_FILE                  10
#define ERR_FILE_WAS_CREATED                    11
#define ERR_INVALID_PASSWORD                    12
#define ERR_WRONG_PASSWORD                      13
#define ERR_INCORRECT_PARAMETERS                14
#define ERR_FILE_MISSING                        15
#define ERR_MEMORY_ALLOCATION                   16
#define ERR_MEMORY_FREE                         17
#define ERR_INVALID_LFHANDLE                    18
#define ERR_MEMORY_LOCK                         18
#define ERR_SLOT_NUM_INVALID                    19
#define ERR_SLOT_EMPTY                          20
#define ERR_SLOTS_FULL                          21
#define ERR_SLOT_ALREADY_ASSIGNED               22
#define ERR_NET_LIC_FULL                        23
#define ERR_COMPNO_NOT_FOUND                    24
#define ERR_VAR_NO_INVALID                      25
#define ERR_SOFT_EXPIRATION                     26
#define ERR_EXPTYPE_INVALID                     27
#define ERR_EXP_DATE_EMPTY                      28
#define ERR_STRING_TOO_LONG                     29
#define ERR_CURRENT_DATE_OLDER                  30
#define ERR_CANNOT_LOCK_FILE                    31
#define ERR_WRONG_LF_VERSION                    32
#define ERR_CORRUPT_LICENSE_FILE                33
#define ERR_SEM_FILE_LOCKED                     34
#define ERR_CORRUPT_CONTROL_FILE                35
#define ERR_WRONG_CF_SERIAL_NUM                 36
#define ERR_LF_LOCKED                           37
#define ERR_LF_CHECKSUM_INVALID                 38
#define ERR_NOT_APPLICABLE                      39
#define ERR_NOT_IMPLEMENTED_YET                 40
#define ERR_FILE_EXISTS                         41
#define ERR_REGISTRY_OPEN                       42
#define ERR_REGISTRY_QUERY                      43
#define ERR_REGISTRY_CLOSE                      44
#define ERR_REGISTRY_READ                       45
#define ERR_REGISTRY_SET                        46
#define ERR_CBOX_NOT_PRESENT                    47
#define ERR_CBOX_WRONG_TYPE                     48
#define ERR_CBOX_READ_RAM1_ERROR                49
#define ERR_CBOX_READ_RAM2_ERROR                50
#define ERR_CBOX_WRITE_RAM1_ERROR               51
#define ERR_CBOX_WRITE_RAM2_ERROR               52
#define ERR_CBOX_ID1_ERROR                      53
#define ERR_CBOX_ID2_ERROR                      54
#define ERR_CBOX_ID3_ERROR                      55
#define ERR_VAR_NOT_AVAILABLE                   56
#define ERR_DEMO_HAS_EXPIRED                    57
#define ERR_WINSOCK_STARTUP_ERROR               58
#define ERR_WINSOCK_CANNOT_RESOLVE_HOST         59
#define ERR_WINSOCK_CANNOT_CREATE_SOCKET        60
#define ERR_WINSOCK_CANNOT_CONNECT_TO_SERVER    61
#define ERR_WINSOCK_CANNOT_SEND_DATA            62
#define ERR_WINSOCK_CANNOT_READ_DATA            63
#define ERR_NO_MORE_SOFTWARE_KEYS_AVAILABLE     64
#define ERR_INVALID_SERVER_RESPONSE             65
#define ERR_CANNOT_ALLOCATE_MEMORY              66
#define ERR_WINSOCK_CANNOT_RESOLVE_PROXY        67
#define ERR_ALIAS_FILE_DOES_NOT_MATCH           68
#define ERR_INVALID_CODE_ENTERED                69
#define ERR_INVALID_REGKEY2_ENTERED             70
#define ERR_ACCESS_DENIED						71
#define ERR_NON_WIN32_OS						72
#define ERR_DRIVER_CORRUPT						73
#define ERR_MARKED_FOR_DELETE					74
//#define ERR_FAKE_FOR_FOXPRO
#define ERR_INVALID_NETHANDLE					75
#define ERR_NO_MESSAGES							76
#define ERR_ALREADY_OPEN						77
#define ERR_INVALID_NETWORK_ADDRESS				78
#define ERR_NON_WIN64_OS						79
#define ERR_NOT_SUPPORTED_BY_OS					80
#define ERR_COULD_NOT_LOAD_DLL					81
#define ERR_FUNCTION_NOT_AVAILABLE				82
#define ERR_NO_DRIVES_FOUND						83
#define ERR_INTERNAL_BROADCAST					84
#define ERR_BIND_FAILED							85
#define ERR_CANNOT_CREATE_THREAD				86
#define ERR_NETWORK_CONNECTIVITY				87
#define ERR_COULD_NOT_INSTALL_DRIVER			88
#define ERR_NETWORK_RECONNECTED					89
#define ERR_NET_MULTI_STARTUP					90
#define ERR_COMPNO_ENHANCED						91

#define ERR_FILE_SIZE_MISMATCH					100
#define ERR_FILE_INCORRECT						101


/* compno returns for COMPNO_BIOS32*/
#define ERR_ACCESS_DENIED_BIOS32				-71
#define ERR_NON_WIN32_OS_BIOS32					-72
#define ERR_DRIVER_CORRUPT_BIOS32				-73
#define ERR_MARKED_FOR_DELETE_BIOS32			-74



/* file attributes defines */
#define PP_NORMAL                0x0000
#define PP_RDONLY                0x0001
#define PP_HIDDEN                0x0002
#define PP_SYSTEM                0x0004

//standard threshhold - used internally only
#define PP_STD_THRESHOLD		20


/* expiration types */
#define EXP_NONE                 "N"
#define EXP_EXE_LIMIT            "E"
#define EXP_SHAREWARE_VER        "S"
#define EXP_PAYMENT_LIMIT        "P"
#define EXP_DEMO_VERSION         "D"


/* getvar / setvar definitions - character fields */
#define VAR_COMPANY                 1
#define VAR_NAME                    2
#define VAR_ADDRESS1                3
#define VAR_ADDRESS2                4
#define VAR_ADDRESS3                5
#define VAR_PHONE1                  6
#define VAR_PHONE2                  7
#define VAR_SERIAL_TEXT             8
#define VAR_EXPIRE_TYPE             9
#define VAR_UDEF_CHAR_1             10
#define VAR_UDEF_CHAR_2             11
#define VAR_UDEF_CHAR_3             12
#define VAR_UDEF_CHAR_4             13
#define VAR_UDEF_CHAR_5             14
#define VAR_UDEF_CHAR_6             15
#define VAR_UDEF_CHAR_7             16
#define VAR_UDEF_CHAR_8             17
#define VAR_UDEF_CHAR_9             18
#define VAR_UDEF_CHAR_10            19
#define VAR_EZTRIAL_COMPNO_DRIVE    20
#define VAR_EZTRIAL_SYSDIR_FILENAME 21
#define VAR_EZTRIG_COMPNO_DRIVE     22
#define VAR_EZTRIAL_REG_ALIAS1      23
#define VAR_EZTRIAL_REG_ALIAS2      24
#define VAR_EZTRIG_DLG_LABELS       25
#define VAR_AUTOCL_PROXY_ADDR       26
#define VAR_AUTOCL_URL_VISIT        27
#define VAR_AUTOCL_URL_BUYNOW       28
#define VAR_AUTOCL_URL_UNLOCK       29
#define VAR_AUTOCL_URL_REGISTER     30
#define VAR_EZTRIAL_COMPNO_FILE		31
#define VAR_EZTRIG_COMPNO_FILE		32
#define VAR_LICENSEPW               33


/* getvar / setvar definitions - numeric fields */
#define VAR_SERIAL_NUM                 1
#define VAR_EXP_COUNT                  2
#define VAR_EXP_LIMIT                  3
#define VAR_LAN_COUNT                  4
#define VAR_LAN_LIMIT                  5
#define VAR_INSTALL_COUNT              6
#define VAR_INSTALL_LIMIT              7
#define VAR_AUTHORIZED_COMPS           8
#define VAR_UDEF_NUM_1                 9
#define VAR_UDEF_NUM_2                 10
#define VAR_UDEF_NUM_3                 11
#define VAR_UDEF_NUM_4                 12
#define VAR_UDEF_NUM_5                 13
#define VAR_LF_CHECKSUM                14
#define VAR_EZTRIAL_SOFT_BINDING       15
#define VAR_EZTRIAL_HARD_BINDING       16
#define VAR_EZTRIAL_COMPNO_THRESHOLD   17
#define VAR_EZTRIAL_CONVERT_COPIES     18
#define VAR_EZTRIAL_UPDATE_LAST_TIME   19
#define VAR_EZTRIAL_COMPNO_ALGORITHMS  20
#define VAR_EZTRIAL_FILE_VERSION       21
#define VAR_EZTRIG_FLAGS               22
#define VAR_EZTRIG_COMPNO_ALGORITHMS   23
#define VAR_EZTRIG_SEED                24
#define VAR_EZTRIG_REGKEY2SEED         25
#define VAR_EZTRIAL_DAYS_TO_RUN        26
#define VAR_EZTRIAL_TIMES_TO_RUN       27
#define VAR_LICENSEID                  28
#define VAR_CUSTOMERID                 29
	


/* getvar / setvar definitions - date fields */
#define VAR_EXP_DATE_SOFT        1
#define VAR_EXP_DATE_HARD        2
#define VAR_LAST_DATE            3
#define VAR_LAST_TIME            4
#define VAR_UDEF_DATE_1          5
#define VAR_UDEF_DATE_2          6
#define VAR_UDEF_DATE_3          7
#define VAR_UDEF_DATE_4          8
#define VAR_UDEF_DATE_5          9


/* for compatibility with previous versions */
#define VAR_PRODUCT              VAR_UDEF_CHAR_2
#define VAR_DISTRIBUTOR          VAR_UDEF_CHAR_3
#define VAR_USER_DEF_1           VAR_UDEF_CHAR_1
#define VAR_USER_DEF_2           VAR_UDEF_NUM_1
#define VAR_USER_DEF_3           VAR_UDEF_NUM_2
#define VAR_USER_DEF_4           VAR_UDEF_DATE_1

