*-----------------------------------------------------------------------------
* xHbTest.prg - based on the WinTest.prg provided with xHarbour, and used to
*                test the use of Softwarekey.com's KeyLib.dll with xHarbour
*                without FWH.  (This works, but sure makes one appreciate FWH!)
*
*              - An example of how to use a basic winapi xHb app for program
*                testing, separated from any GUI that might be a problem.
*
*              - This an xHb app shell into which you can copy code from 
*                PlusTest.prg as needed for testing.
*
*              - Must link in ppp4xhb.prg (contains all PLUS function calls)
*              - Note: an xBuilder project file is included: xHbTest.exe.xbp
*-----------------------------------------------------------------------------

STATIC hPppDll,nCtrlID,hWnd,hDC
STATIC s_oControl := NIL
STATIC lDirect := .f.

#include "hbdll.ch"

#include "DLLxHb.ch"
#include "Keylib.ch"

#include "winapi.ch"
#include "wingdi.ch"

#define True   1
#define False  0

// Setup menu commands...
#define IDM_FIRST              5001
#define IDM_DIRECT             5002
#define IDM_THIRD              5003
#define IDM_FOURTH             5004
#define IDM_FIFTH              5005
#DEFINE IDM_EXIT               5006

#define IDM_SIXTH              6006
#define IDM_SEVENTH            6007
#define IDM_EIGHTH             6008
#DEFINE IDM_NINTH              6009


// The following line is an alternate way to define whether we're accessing 
// DLLCALL directly or indirectly via DLLxHb.ch. To use DLLCALL directly, 
// without using lDirect, uncomment this line...
//                     (now replaced by lDirect, a f-w static )
//#define __DIRECT__

#xtranslate TextOut( <x,...> ) =>

PROCEDURE Main()

*   LOCAL hWnd
   LOCAL wc := (struct WNDCLASS)
   LOCAL msg
   LOCAL hMenu, hFileMenu, hEditMenu

   wc:style         := CS_OWNDC | CS_DBLCLKS
   wc:lpfnWndProc   := WinCallBackPointer( @MainWndProc() )
   //wc:cbClsExtra    := 0
   //wc:cbWndExtra    := 0
   wc:hInstance     := GetModuleHandle()
   //wc:hIcon         := 0
   wc:hCursor       := LoadCursor( NIL, IDC_IBEAM )
   wc:hbrBackground := COLOR_WINDOW + 1
   wc:lpszClassName := "TestWindow"
   //wc:lpszMenuName  := NIL

   hPppDll  := LoadLibrary( "Keylib32.DLL" )

*  SETHandle(hPppDll)  // Could put this func in another prg to send it hPppDll

   IF RegisterClass( wc ) > 0

      // Make the main app window...
      hWnd := CreateWindowEx( 0, "TestWindow", ;
                              "ProPLUS Tests - With Basic Winapi Window", ;
                              WS_OVERLAPPEDWINDOW, ;
                              100, 100, 800, 600, 0, 0, wc:hInstance, NIL )

      // Build the "File" menu (first menu) for the main window...
      hFileMenu := CreatePopupMenu()
      AppendMenu( hFileMenu, MF_STRING, IDM_FIRST,              "&First test" )
      AppendMenu( hFileMenu, MF_STRING, IDM_DIRECT,             "&Toggle Direct/Indirect DLLCALL" )
      AppendMenu( hFileMenu, MF_STRING, IDM_THIRD,              "&Third test" )
      AppendMenu( hFileMenu, MF_STRING, IDM_FOURTH,             "&Fourth test" )
      AppendMenu( hFileMenu, MF_STRING, IDM_FIFTH,              "F&ifth test" )
      AppendMenu( hFileMenu, MF_STRING, IDM_EXIT,               "&Exit" )

      // Build the "Edit" menu (second menu) for the main window...
      hEditMenu := CreatePopupMenu()
      AppendMenu( hEditMenu, MF_STRING, IDM_SIXTH,              "&Sixth test" )
      AppendMenu( hEditMenu, MF_STRING, IDM_SEVENTH,            "S&eventh test" )
      AppendMenu( hEditMenu, MF_STRING, IDM_EIGHTH,             "&Eighth test" )
      AppendMenu( hEditMenu, MF_STRING, IDM_NINTH,              "&Ninth test" )

      hMenu := CreateMenu()
      AppendMenu( hMenu, MF_POPUP, hFileMenu, "&ProPLUS tests" )
      AppendMenu( hMenu, MF_POPUP, hEditMenu, "&A second menu" )

      SetMenu( hWnd, hMenu )


      IF hWnd > 0
         ShowWindow( hWnd, SW_SHOW )

         WHILE GetMessage( @msg, 0, 0, 0 )
            TranslateMessage( msg )
            DispatchMessage( msg )
         END
      ELSE
         TraceLog( GetLastError(), FormatMessage() )
         Alert( "Failed to create window!" )
      ENDIF
   ELSE
      TraceLog( GetLastError(), FormatMessage() )
      Alert( "Failed to register class!" )
   ENDIF

   FreeLibrary( hPppDll )

   RETURN

         // Processing of menu options, and other housekeeping...
FUNCTION MainWndProc( hWnd, message, wParam, lParam )

   LOCAL ps
   STATIC nCnt := 0

   //TraceLog( hWnd, message, wParam, lParam )

   SWITCH message

      CASE WM_SIZE
         IF s_oControl != NIL
            s_oControl:__OnSize()
         ENDIF

         RETURN 0

      CASE WM_COMMAND        // Process menu selection...
         s_oControl := NIL

         SWITCH LOWORD( wParam )
            CASE IDM_FIRST
               IF nCnt = 0         // Prevent recursion.
                  MessageBox(hWnd,"First option.","Info:")
               ENDIF
               nCnt++
               EXIT

            CASE IDM_DIRECT
               IF !lDirect
                  lDirect := .t.
                  MessageBox(hWnd,"lDirect is true.","Info:")
               ELSE
                  lDirect := .f.
                  MessageBox(hWnd,"lDirect is false.","Info:")
               ENDIF
               EXIT

            CASE IDM_THIRD
               MessageBox(hWnd,"Third option.","Info:")
               nCnt := 0
               EXIT

            CASE IDM_FOURTH
               TRY
                  MessageBox(hWnd,"Fourth test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, fourth option not available." )
               END
               EXIT

            CASE IDM_FIFTH
               TRY
                  MessageBox(hWnd,"Fifth test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, fifth option not available." )
               END
               EXIT

            CASE IDM_EXIT
               MessageBox(hWnd,"Please click on X at upper right corner..","Info:")
               EXIT

            CASE IDM_SIXTH
               TRY
                  MessageBox(hWnd,"Sixth test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, sixth option not available." )
               END
               EXIT

            CASE IDM_SEVENTH
               TRY
                  MessageBox(hWnd,"Seventh test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, seventh option not available." )
               END
               EXIT

            CASE IDM_EIGHTH
               TRY
                  MessageBox(hWnd,"Eighth test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, eighth option not available." )
               END
               EXIT

            CASE IDM_NINTH
               TRY
                  MessageBox(hWnd,"Ninth test called - inactive.","Info:")
               CATCH
                  Alert( "Sorry, ninth option not available." )
               END
               EXIT

         END
         RETURN 0


      CASE WM_SETFOCUS
         RETURN 0

      CASE WM_CREATE
         RETURN 0

      CASE WM_DESTROY
         PostQuitMessage( 0 )
         TraceLog( "Quit" )
         RETURN 0
   END

RETURN DefWindowProc( hWnd, message, wParam, lParam )
*----------------------------------------------------
FUNCTION FirstOption() 
LOCAL nRetVal := 0

// IF lDirect = .t. (or __DIRECT__ in prior version) then we are invoking 
// DLLCALL() directly, without going to it through DLLxHb.ch .  The advantage
// of the indirect approach is that the syntax is simpler, and all trailing
// params don't have to be provided because thy will automatically be provided
// as nil by DLLxHb's function calls through DLLxHb.ch .

// The reason for testing direct versus indirect calls to DLLCALL is that
// some early errors were hard to pin down, and so we needed to determine if
// the problem was in whether a function was called directely or indirectly. We
// found that this wasn't really a factor, except that when calling directly
// we had to be sure to put in commas for unused trailing params or we'd get
// a GPF.


/* Example of calling xHarbour's DLLCALL directly, or alternatively, using
   an indirect call to DLLCALL through DLLxHb.ch.  In this example, working
   with an RMCHart DLL's function...

//#ifdef __DIRECT__
IF lDirect
   nRetVal = DLLCALL( hRmcDll, DC_CALL_STD, ;
             "RMC_CREATECHART", hWnd, nCtrlID, 0, 0, ;
                       600, 450, ColorAzure, RMC_CTRLSTYLEFLAT, , , , , )

//  MessageBox(hWnd,"__DIRECT__ is T","__DIRECT__ status:")
    MessageBox(hWnd,"lDirect is T","lDIRECT status:")
//#else
ELSE
   nRetVal = RMC_CREATECHART( hWnd, nCtrlID, 0, 0, ;
                       600, 450, ColorAzure, RMC_CTRLSTYLEFLAT ) //, False, "")

//  MessageBox(hWnd,"__DIRECT__ is F","__DIRECT__ status:")
    MessageBox(hWnd,"lDirect is .f.","lDirect status:")

//#endif
ENDIF
*/

   TraceLog( nRetVal ) // for testing, can write data to a trace log.


RETURN nil
*---------------------------------
// dummy funcs to mask some FWH funcs...
FUNCTION OEMTOCHARA() ; RETURN nil
FUNCTION SysRefresh() ; RETURN nil
FUNCTION CursorWait() ; RETURN nil
FUNCTION CursorArrow() ; RETURN nil
*----------------------------------------------------
*--------------------------------------------------------
